/* ---------------------------------------------------------- */
/*  kome_audio_drv.h                                          */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief		V850/DAC audio driver
    @author		rerofumi
    @since		Jul.13.2007
*/
/*-----------------------------------------------------
 Copyright (C) 2007 rerofumi <rero2@yuumu.org>
 -  Kome wo kame.
 ------------------------------------------------------*/

#ifndef KOME_AUDIO_DRV_H
#define KOME_AUDIO_DRV_H

#pragma ioreg


/*-------------------------------*/
/* include                       */
/*-------------------------------*/

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/* --- o̓obt@TCY */
#define KOMEAUDIO_BUFFERSIZE   32

/* --- o̓^C}[ */
#define KOMEAUDIO_TIMER   64

/* --- `l */
#define KOMEAUDIO_CHANNEL   4

/* --- ߂l */
enum {
  AUDIO_DONE = 0,
  AUDIO_ERROR,
  AUDIO_NOT_ENABLE,
  AUDIO_WRONG_CHANNEL,
  AUDIO_IS_BUSY
};

/*-------------------------------*/
/* struct                        */
/*-------------------------------*/

/* --- `l\ */
typedef struct {
  unsigned char *data;
  int  rest;
  int  size;
  int  repeat;
} KAudioChannel, *PKAudioChannel;


/*-------------------------------*/
/* prototype                     */
/*-------------------------------*/


//! Audio hCȍ
int komeAudioInitialize(void);

//! Audio hCo̓X^[g
int komeAudioStart(void);

//! Audio hCo̓~
int komeAudioStop(void);

//! channel se request
int komeAudioSERequest(int ch, unsigned char *ptr, int size, int repeat);

//! channel stop request
int komeAudioSEStop(int ch);

//! channel busy status
int komeAudioChannelStatus(int ch);



#endif
