/* ---------------------------------------------------------- */
/*  lcd_module.h                                              */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief		V850/LCD module controller
    @author		rerofumi
    @since		Apr.14.2007
*/
/*-----------------------------------------------------
 Copyright (C) 2007 rerofumi <rero2@yuumu.org>
 All Rights Reserved.
 ------------------------------------------------------*/

#ifndef LCD_MODULE_H
#define LCD_MODULE_H

#pragma ioreg


/*-------------------------------*/
/* include                       */
/*-------------------------------*/

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/* --- gp|[g̐ݒ */
#define LCD_E  		P0.6
#define LCD_RW 		P0.4
#define LCD_RS 		P0.3
#define LCD_DB4		P7H.0
#define LCD_DB5		P7H.1
#define LCD_DB6		P7H.2
#define LCD_DB7		P7H.3

#define LCD_PORT_MODE  PM7H
#define LCD_PORT_MASK  0x0f
#define LCD_PORT2_MODE PM0
#define LCD_PORT2_MASK 0x58

/* --- J[\̗L薳 */
#define LCD_MODE_DISPCURSOR   0

/* --- ߂l */
enum {
	LCD_DONE = 0,
	LCD_ERROR_NOT_OPEN,
	LCD_ERROR_ARGMENT,
	LCD_ERROR,
};

/*-------------------------------*/
/* struct                        */
/*-------------------------------*/

/*-------------------------------*/
/* prototype                     */
/*-------------------------------*/

//! 1ms ҂[`
void  wait_1ms(int msec);


//! LCD W[̏
int	lcdInitialize(void);

//! LCD W[ Busy ҂
int lcdWaitBusy(void);

//! LCD W[ɃR}hM
int lcdSendCommand(unsigned char com);

//! LCD W[ǂݍ
int lcdReceiveByte(unsigned char *dat);

//! ʃNA
int lcdClearScreen(void);

//! \ʒuw
int lcdLocate(int x, int y);

//! 1M
int lcdPutChar(unsigned char dat);

//! 1byte hex
int lcdPutHexByte(unsigned char num);

//! 2byte hex
int lcdPutHexShort(unsigned short num);

//! \
int lcdPutMessage(unsigned char *string);


#endif
